<template>
  <div class="page-box" style="position: relative;">
    <el-form
      ref="formTourCarModelRef"
      :size="layoutStore.defaultFormItemSize"
      label-width="120px"
      label-position="right"
      @submit.prevent
    >
      <filter-box :item-width="350" @search="refreshFormTourCarModel()" @reset="resetFormTourCarModel">
        <el-form-item label="车型名称">
          <el-input
            class="filter-item"
            v-model="formFilter.typeNameFilter"
            type="text"
            placeholder=""
            :clearable="true"
            :show-word-limit="false"
            maxlength=""
          />
        </el-form-item>
      </filter-box>
    </el-form>
    <table-box
      ref="formTourCarModelTable"
      class="page-table"
      :data="formTourCarModelTableWidgetDataList"
      :size="layoutStore.defaultFormItemSize"
      :row-config="{isCurrent: false, isHover: true}"
      :seq-config="{startIndex: ((formTourCarModelTableWidgetCurrentPage - 1) * formTourCarModelTableWidgetPageSize)}"
      :sort-config="{remote: true}"
      :hasExtend="true"
      @sort-change="formTourCarModelTableWidget.onSortChange"
      @refresh="formTourCarModelTableWidget.refreshTable()"
    >
      <template #operator>
        <el-button
          type="primary"
          :size="layoutStore.defaultFormItemSize"
          @click="onAddTourCarModelClick()"
          >
          新建
        </el-button>
        <el-button
          type="primary"
          :size="layoutStore.defaultFormItemSize"
          @click="onExportTourCarModelClick()"
          >
          导出
        </el-button>
        <el-upload
          class="btn-import"
          :auto-upload="false"
          action=""
          :show-file-list="false"
          accept=".xls,.xlsx"
          style="display: inline-block;"
          :on-change="onImportTourCarModelClick"
        >
          <template #trigger>
            <el-button
              type="primary"
              :size="layoutStore.defaultFormItemSize"
            >
              导入
            </el-button>
          </template>
        </el-upload>
      </template>
      <vxe-column title="序号" type="seq" :index="formTourCarModelTableWidget.getTableIndex" :width="80" />
      <vxe-column title="车型名称" field="typeName" />
      <vxe-column title="车型图片" min-width="100px">
        <template v-slot="scope">
          <upload-file-list
            :file-list="
              parseUploadData(scope.row.typeUrl, {
                id: scope.row.id,
                fieldName: 'typeUrl',
                asImage: true
              })
            "
            type="card"
            direction="horizontal"
            :readonly="true"
          />
        </template>
      </vxe-column>
      <vxe-column title="是否启用" field="enableDictMap.name" />
      <vxe-column title="排序" field="showOrder" />
      <vxe-column title="操作" fixed="right">
        <template v-slot="scope">
          <el-button
            link
            type="primary"
            :size="layoutStore.defaultFormItemSize"
            @click.stop="onEditTourCarModelClick(scope.row)"
          >
            编辑
          </el-button>
          <el-button
            link
            type="primary"
            :size="layoutStore.defaultFormItemSize"
            @click.stop="onDeleteTourCarModelClick(scope.row)"
          >
            删除
          </el-button>
        </template>
      </vxe-column>
      <template slot="empty">
        <div class="table-empty unified-font">
          <img src="@/assets/img/empty.png">
          <span>暂无数据</span>
        </div>
      </template>
      <!-- 分页 -->
      <template #pagination>
        <el-row type="flex" justify="end" style="margin-top: 10px;">
          <el-pagination
            :total="formTourCarModelTableWidgetTotalCount"
            :current-page="formTourCarModelTableWidgetCurrentPage"
            :page-size="formTourCarModelTableWidgetPageSize"
            :page-sizes="[10, 20, 50, 100]"
            layout="total, prev, pager, next, sizes"
            @current-change="formTourCarModelTableWidget.onCurrentPageChange"
            @size-change="formTourCarModelTableWidget.onPageSizeChange">
          </el-pagination>
        </el-row>
      </template>
    </table-box>
    <label v-if="subPage" class="page-close-box" @click="onCancel()">
      <img src="@/assets/img/back2.png" alt="">
    </label>
  </div>
</template>

<script lang="ts">
export default {
  name: 'formTourCarModel',
};
</script>

<script setup lang="ts">
import { VxeColumn, VxeTable } from 'vxe-table';
import { ANY_OBJECT } from '@/types/generic';
import { DictData, DictionaryBase } from '@/common/staticDict/types';
import { ElMessage, ElMessageBox, UploadFile } from 'element-plus';
import { useRoute, useRouter } from 'vue-router';
import { useCommon } from '@/common/hooks/useCommon';
import { useLayoutStore, useStaticDictStore } from '@/store';
import { useDownload } from '@/common/hooks/useDownload';
import { useDropdown } from '@/common/hooks/useDropdown';
import { DropdownOptions, ListData } from '@/common/types/list';
import { useTable } from '@/common/hooks/useTable';
import { TableOptions } from '@/common/types/pagination';
import { useUpload } from '@/common/hooks/useUpload';
import { useUploadWidget } from '@/common/hooks/useUploadWidget';
import { DictionaryController } from '@/api/system';
import { treeDataTranslate, findItemFromList, findTreeNodePath, findTreeNode, stringCase } from '@/common/utils';
import { TourCarModelData } from '@/api/generated/tourCarModelController';
import { TourCarModelController } from '@/api/generated';
import FormEditTourCarModel from '@/pages/tourCarModel/formEditTourCarModel.vue';

const router = useRouter();
const route = useRoute();
const layoutStore = useLayoutStore();
const { downloadFile } = useDownload();
const { getUploadHeaders, getUploadActionUrl, fileListToJson, parseUploadData, getPictureList } = useUpload();
const { 
  Delete,
  Search,
  Edit,
  Plus,
  Refresh,
  Picture,
  Dialog,
  mainContextHeight,
  clientHeight,
  checkPermCodeExist,
  parseParams,
  parseArrayParams,
  formatDateByStatsType,
  getDateRangeFilter,
} = useCommon();
// 静态字典
const { staticDict: StaticDict } = useStaticDictStore();

const props = withDefaults(
  defineProps<{
    subPage?: number | string | boolean;
  }>(),
  {
    subPage: 0,
  },
);

const formFilter = reactive({
  // 车型名称
  typeNameFilter: undefined,
});
const formFilterCopy = reactive({
  // 车型名称
  typeNameFilter: undefined,
});

const onCancel = () => {
  layoutStore.removeCachePage(route.name as string);
  route.meta.refreshParentCachedPage = true;
  router.go(-1);
};

const onResume = () => {
  refreshFormTourCarModel();
};

/**
 * 表格组件数据获取函数，返回Promise
 */
const loadFormTourCarModelTableWidgetData = (params: ANY_OBJECT) => {
  if (params == null) params = {};
  params = {
    ...params,
    tourCarModelDtoFilter: {
      typeName: formFilter.typeNameFilter,
    }
  };
  return new Promise((resolve, reject) => {
    TourCarModelController.list(params).then(res => {
      resolve({
        dataList: res.data.dataList,
        totalCount: res.data.totalCount
      });
    }).catch(e => {
      reject(e);
    });
  });
};
/**
 * 表格组件数据获取检测函数，返回true正常获取数据，返回false停止获取数据
 */
const loadFormTourCarModelTableVerify = () => {
  formFilterCopy.typeNameFilter = formFilter.typeNameFilter;
  return true;
};
/**
 * 新建
 */
const onAddTourCarModelClick = (row?: TourCarModelData) => {
  let params: ANY_OBJECT = {
  };

  Dialog
    .show('新建', FormEditTourCarModel, { area: '900px' }, { ...params, subPage: true })
    .then(res => {
      formTourCarModelTableWidget.refreshTable();
    }).catch(e => {
      // TODO: 异常处理
      console.error(e);
    });
};
/**
 * 编辑
 */
const onEditTourCarModelClick = (row?: TourCarModelData) => {
  let params: ANY_OBJECT = {
    id: row?.id,
  };

  Dialog
    .show('编辑', FormEditTourCarModel, { area: '900px' }, { ...params, subPage: true })
    .then(res => {
      formTourCarModelTableWidget.refreshTable();
    }).catch(e => {
      // TODO: 异常处理
      console.error(e);
    });
};
/**
 * 导出
 */
const onExportTourCarModelClick = (row?: TourCarModelData) => {
  let params: ANY_OBJECT = {
  };

  TourCarModelController.export(params, '表格组件.xlsx').then(res => {
    ElMessage.success('导出成功');
  }).catch(e => {
    ElMessage.error(e.errorMessage);
  });
};
/**
 * 导入
 */
const onImportTourCarModelClick = (file) => {
  let params: ANY_OBJECT = {
    importFile: file.raw,
    // 是否忽略表头
    skipHeader: false
  };

  TourCarModelController.import(params).then(res => {
    ElMessage.success('导入成功');
    formTourCarModelTableWidget.refreshTable();
  }).catch(e => {
    // TODO: 异常处理
    console.error(e);
  });
};
/**
 * 删除
 */
const onDeleteTourCarModelClick = (row?: TourCarModelData) => {
  let params: ANY_OBJECT = {
    id: row?.id,
  };

  ElMessageBox.confirm('是否删除此记录？').then(res => {
    TourCarModelController.delete(params).then(res => {
      ElMessage.success('删除成功');
      formTourCarModelTableWidget.refreshTable(false, 1);
    }).catch(e => {
      // TODO: 异常处理
      console.error(e);
    });
  }).catch(e => {
    // TODO: 异常处理
    console.error(e);
  });
};
// 表格组件表格组件参数
const formTourCarModelTableOptions: TableOptions<TourCarModelData> = {
  loadTableData: loadFormTourCarModelTableWidgetData,
  verifyTableParameter: loadFormTourCarModelTableVerify,
  paged: true,
  rowSelection: false,
  orderFieldName: undefined,
  ascending: true,
};
// 表格组件表格组件
const formTourCarModelTable = ref();
const formTourCarModelTableWidget = useTable(formTourCarModelTableOptions);
const {
  dataList: formTourCarModelTableWidgetDataList,
  currentPage: formTourCarModelTableWidgetCurrentPage,
  pageSize: formTourCarModelTableWidgetPageSize,
  totalCount: formTourCarModelTableWidgetTotalCount,
} = formTourCarModelTableWidget;
const refreshFormTourCarModel = () => {
  // 刷新段落
  formTourCarModelTableWidget.refreshTable();
};
/**
 * 重置过滤值
 */
const resetFormTourCarModel = () => {
  formFilter.typeNameFilter = undefined;
  formFilterCopy.typeNameFilter = undefined;
  refreshFormTourCarModel();
};
/**
 * 重置所有过滤值
 */
const resetFilter = () => {
  resetFormTourCarModel();
};
const formInit = () => {
  refreshFormTourCarModel();
};

onMounted(() => {
  formInit();
});
</script>